> For the complete documentation index, see [llms.txt](https://docs.licensespring.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.licensespring.com/license-api/license-activation-and-deactivation/activate-bundle-online-method.md).

# Activate Bundle (Online Method)

### Endpoint

* Method: `POST`
* Path: `/api/v4/activate_bundle`
* Description: Activates all licenses inside a bundle and returns the activated licenses list.

### Authentication

See [License API Authorization](/license-api/license-api-authorization.md).

#### Required headers

* `Date` (string) — RFC7231 GMT date string
* `Authorization` (string) — signature or bearer token

#### Recommended headers

* `Accept: application/json`
* `Content-Type: application/json`

### Request

#### Body parameters

Required:

* `hardware_id` (string) — Unique hardware ID generated for the client device
* `product` (string) — Bundle product short code

One of:

* `license_key` (string) — For key-based bundles
* `username` + `password` (string) — For user-based bundles
* `id_token` + `customer_account_code` (string) — SSO Implicit grant
* `code` + `customer_account_code` (string) — SSO Authorization Code grant

Optional:

* `license_id` (number)
* `is_vm` (boolean)
* `vm_info` (string)
* `os_ver` (string)
* `hostname` (string)
* `os_hostname` (string)
* `ip` (string)
* `ip_local` (string)
* `app_ver` (string)
* `sdk_ver` (string)
* `mac_address` (string)
* `variables` (object)

#### Minimal example (JSON)

```json
{
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}
```

### Examples

{% tabs %}
{% tab title="curl" %}

```bash
curl --location --request POST '/api/v4/activate_bundle' \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--header 'Date: string' \
--header 'Authorization: string' \
--data-raw '{
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}'
```

{% endtab %}

{% tab title="nodejs" %}

```javascript
var request = require('request');

var options = {
  method: 'POST',
  url: '/api/v4/activate_bundle',
  headers: {
    'Accept': 'application/json',
    'Content-Type': 'application/json',
    'Date': 'string',
    'Authorization': 'string'
  },
  body: JSON.stringify({
    hardware_id: 'some-unique-id',
    product: 'BUNDLE',
    license_key: 'AAAA-BBBB-CCCC-DDDD'
  })
};

request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

{% endtab %}

{% tab title="javascript (fetch)" %}

```javascript
var myHeaders = new Headers();
myHeaders.append("Accept", "application/json");
myHeaders.append("Content-Type", "application/json");
myHeaders.append("Date", "string");
myHeaders.append("Authorization", "string");

var raw = JSON.stringify({
  hardware_id: "some-unique-id",
  product: "BUNDLE",
  license_key: "AAAA-BBBB-CCCC-DDDD"
});

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: raw,
  redirect: 'follow'
};

fetch("/api/v4/activate_bundle", requestOptions)
  .then(response => response.text())
  .then(result => console.log(result))
  .catch(error => console.log('error', error));
```

{% endtab %}

{% tab title="python" %}

```python
import requests

url = "/api/v4/activate_bundle"

payload = {
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}

headers = {
  "Accept": "application/json",
  "Content-Type": "application/json",
  "Date": "string",
  "Authorization": "string"
}

response = requests.post(url, json=payload, headers=headers)
print(response.text)
```

{% endtab %}

{% tab title="ruby" %}

```ruby
require "uri"
require "net/http"
require "json"

url = URI("/api/v4/activate_bundle")

http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Accept"] = "application/json"
request["Content-Type"] = "application/json"
request["Date"] = "string"
request["Authorization"] = "string"
request.body = JSON.dump({
  hardware_id: "some-unique-id",
  product: "BUNDLE",
  license_key: "AAAA-BBBB-CCCC-DDDD"
})

response = http.request(request)
puts response.read_body
```

{% endtab %}
{% endtabs %}

### Schema

#### Request Body

<details>

<summary><strong>Request schema (TypeScript + JSON Schema)</strong></summary>

**TypeScript**

```typescript
type BundleActivationRequestBody = ({

  // for key-based licenses:
  license_key: string

} | {

  // for user-based licenses:
  username: string
  password: string

} | {

  // for user-based licenses using single sign-on Implicit grant:
  id_token: string
  customer_account_code: string

} | {

  // for user-based licenses using single sign-on Authorization code grant:
  code: string
  customer_account_code: string

}) & {

  // required properties:
  hardware_id: string
  product: string

  // optional properties:
  bundle_code?: string | undefined
  license_id?: number | undefined
  is_vm?: boolean | undefined
  vm_info?: string | undefined
  os_ver?: string | undefined
  hostname?: string | undefined
  os_hostname?: string | undefined
  ip?: string | undefined
  ip_local?: string | undefined
  app_ver?: string | undefined
  sdk_ver?: string | undefined
  mac_address?: string | undefined
  variables?: { [key: string]: string } | undefined
}
```

**JSON Schema**

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "allOf": [
    {
      "oneOf": [
        {
          "type": "object",
          "properties": {
            "license_key": { "type": "string" }
          },
          "required": ["license_key"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "username": { "type": "string" },
            "password": { "type": "string" }
          },
          "required": ["username", "password"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "id_token": { "type": "string" },
            "customer_account_code": { "type": "string" }
          },
          "required": ["id_token", "customer_account_code"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "code": { "type": "string" },
            "customer_account_code": { "type": "string" }
          },
          "required": ["code", "customer_account_code"],
          "additionalProperties": false
        }
      ]
    },
    {
      "type": "object",
      "properties": {
        "hardware_id": { "type": "string" },
        "product": { "type": "string" },
        "bundle_code": { "type": "string" },
        "license_id": { "type": "number" },
        "is_vm": { "type": "boolean" },
        "vm_info": { "type": "string" },
        "os_ver": { "type": "string" },
        "hostname": { "type": "string" },
        "os_hostname": { "type": "string" },
        "ip": { "type": "string" },
        "ip_local": { "type": "string" },
        "app_ver": { "type": "string" },
        "sdk_ver": { "type": "string" },
        "mac_address": { "type": "string" },
        "variables": {
          "type": ["object", "null"],
          "additionalProperties": { "type": "string" }
        }
      },
      "required": ["hardware_id", "product"],
      "additionalProperties": false
    }
  ]
}
```

</details>

#### Response Body

<details>

<summary><strong>Response schema (TypeScript + JSON Schema)</strong></summary>

**TypeScript**

```typescript
// Response is a list of activated licenses.
// Each item matches the Activate License (Online) response schema.
type BundleActivationResponseList = LicenseActivationResponseBody[];
```

**JSON Schema**

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "array",
  "items": {
    "type": "object"
  }
}
```

</details>

See [Activate License *Online Method*](/license-api/license-activation-and-deactivation/activate-license-online-method.md) for the item schema.

### License Authorization Method

There are two types of product licenses based on how the client application authorizes itself to interact with a license:

#### Key-based product licenses

Each license assigned to the product requires the client to provide a license key in order to activate, check or deactivate the license (property `license_key` in the request body).

The license response object will contain the `license_key` property, and the property `product_details.authorization_method` will be the string `license_key`.

#### User-based product licenses

Each license assigned to the product has a corresponding "license user" instead of a license key. There are multiple ways a user-based product license can be accessed when making a request:

* By providing the values for `username` and `password` for the license user
* By providing the values for `id_token` and `customer_account_code` if using single sign-on authentication using Implicit grant
* By providing the values for `code` and `customer_account_code` if using single sign-on authentication using Authorization code grant

In the license response object, `product_details.authorization_method` will have the string value `user` and the response object will contain the `user` object with information on the license user.

### License Types

The `license_type` property defines one of the 4 types of licenses based on their duration and how the license is used:

* Perpetual: `perpetual`
* Time-limited: `time-limited`
* Subscription: `subscription`
* Consumption: `consumption`

For more information see: [**License Types**](/license-entitlements/license-types.md)

### Errors

If an error occurs, the response will have an HTTP status code of 400 or higher, and the response body will contain an error description in the following format:

```typescript
{
  status: number,
  code: string,
  message: string
}
```

JSON Schema

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "status": { "type": "number" },
    "code": { "type": "string" },
    "message": { "type": "string" }
  },
  "required": [
    "status",
    "code",
    "message"
  ],
  "additionalProperties": false
}
```

### List of Exceptions

* unknown\_product (400): Provided product was not found
* product\_not\_bundle (400): Specified product "code" is not a bundle
* license\_not\_found (400): License with the provided license user not found
* license\_not\_enabled (400): The license is not enabled
* vm\_not\_allowed (400): Virtual machine not allowed
* offline\_floating\_cloud\_not\_supported (400): Floating cloud licenses cannot be activated offline
* license\_start\_date\_error (400): This license cannot be activated before start date: {date}
* blacklisted (400): This device is blacklisted
* license\_activated\_max\_times (400): This license key has already been activated the maximum number of times
* license\_user\_activated\_max\_times (400): License user has activated this license max times
* license\_expired (400): License validity period has expired
* license\_transferred\_max\_times (400): This license has already been transferred the maximum number of times
* license\_device\_exists (409): A device matching this hardware\_id is already created on the license.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.licensespring.com/license-api/license-activation-and-deactivation/activate-bundle-online-method.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
